#import <CoreAudio/CoreAudio.h>
#import <Foundation/Foundation.h>
#import <unistd.h>


// prototypes
int playAiffFile(char filename[]);

int findAudioData(char filename[]);

int playAudio();

int stopAudio();

int cleanUp();

int setupOutputDevice();

OSStatus audioDeviceIOProc(AudioDeviceID inDevice,
                           const AudioTimeStamp *inNow,
                           const AudioBufferList *inInputData,
                           const AudioTimeStamp *inInputTime,
                           AudioBufferList *outOutputData,
                           const AudioTimeStamp *inOutputTime,
                           void *inClientData);

unsigned int AIFFRead(FILE *imafile,
                      short samples[],
                      unsigned int sampleCount);

// type declerations
typedef struct _AIFFChunkHeader {
    unsigned int chunkID;
    unsigned int chunkSize;
    unsigned int fileType;
} AIFFChunkHeader;

typedef struct {
    /*
    unsigned int ckID;
    unsigned int ckDataSize;
     */
    short numChannels;
    unsigned long numSampleFrames;
    short sampleSize;
    unsigned int sampleRate;
    unsigned int compressionType;
    unsigned int compressionName;
} AIFFCommonChunk;

typedef struct _AIFFGenericChunk {
    unsigned int chunkID;
    unsigned int chunkSize;
} AIFFGenericChunk;

typedef struct _AIFFSSNDData {
    unsigned int offset;
    unsigned int blockSize;
} AIFFSSNDData;