#import <Foundation/Foundation.h>
#import "Socket.h"

#define arraySize 10

Socket *mySocket;

/***
This program receives 10 shorts (20 bytes)
from a socket and displays them.
***/

int main (int argc, const char * argv[]) {
    NSAutoreleasePool * pool = [[NSAutoreleasePool alloc] init];

    short int end[arraySize];
    NSMutableData *caught;
    int i, port, returned; port = 3030;
    NSString *host = [[NSString alloc] initWithCString:argv[1]];

    // initialize buffer
    for ( i = 0; i < arraySize; i++)
        end[i] = 0;
    // show its contents
    for ( i = 0; i < arraySize; i++)
        NSLog(@"end[%i]:%i", i, end[i]);

    // initialize socket
    mySocket = [[Socket alloc] init];
    [mySocket setReadBufferSize:(arraySize * sizeof(short))];

    // connect to host
    [mySocket connectToHostName:host port:port];

    // receive data from socket
//    caught = [[NSMutableData alloc] initWithLength:arraySize];
    caught = [[NSMutableData alloc] initWithCapacity:(arraySize * sizeof(short))];
    returned = [mySocket readData:caught];
    
    // put data in buffer
    [caught getBytes:end];
    [caught release];
    
    NSLog(@"******************");
    NSLog(@"number of byets received:%i", returned);

    // show contents of buffer
    for ( i = 0; i < arraySize; i++)
        NSLog(@"end[%i]:%i", i, end[i]);

    NSLog(@"Goodbye.");
    
    [pool release];
    return 0;
}
