#import <Foundation/Foundation.h>
#import <unistd.h>
#import "Socket.h"

#define arraySize (4*1024)

void signal_handler(int sig);

Socket *mySocket;
char end[arraySize];

/***
This program reads buffers of text data
from a socket and dsiplays them on the screen.
***/

int main (int argc, const char * argv[]) {
    NSAutoreleasePool * pool = [[NSAutoreleasePool alloc] init];

    NSMutableData *caught;
    int i, port, returned; port = 3030;
    NSString *host = [[NSString alloc] initWithCString:"localhost"];
    static struct sigaction act;

    // trap SIGINT
    act.sa_handler = *signal_handler;
    sigfillset(&(act.sa_mask));
    sigaction(SIGINT, &act, NULL);

    // initialize buffer
    for ( i = 0; i < arraySize; i++)
        end[i] = '0';
    
    // show buffer contents
    //for ( i = 0; i < arraySize; i++)
    //NSLog(@"end[%i]:%i", i, end[i]);

    // initialize socket
    mySocket = [[Socket alloc] init];
    [mySocket setReadBufferSize:(arraySize * sizeof(char))];

    // connect to host
    [mySocket connectToHostName:host port:port];
    [host release];
//    [mySocket setBlocking:FALSE];

    while ( [mySocket isConnected] ) {
        // receive data from socket
        //caught = [[NSMutableData alloc] initWithLength:arraySize];
        caught = [[NSMutableData alloc] initWithCapacity:(arraySize * sizeof(char))];

        returned = [mySocket readData:caught];

        // put data in buffer
        [caught getBytes:end];
        [caught release];
        
        // show contents of buffer
        for ( i = 0; i < arraySize; i++)
            printf("%c", end[i]);
        //        NSLog(@"%c", end[i]);
        //        NSLog(@"end[%i]:%c", i, end[i]);

        NSLog(@"******************");
        NSLog(@"number of bytes received:%i", returned);

        usleep( 2 * 1000 * 1000 );
    }

    [mySocket release];
    NSLog(@"Normal termination.\nGoodbye.");
    
    [pool release];
    return 0;
}

void signal_handler(int sig) {
    NSLog(@"^C Handled.\nGoodbye.\n");
    if ( [mySocket isConnected] ) {
        [mySocket release];
    }
    exit(1);
}