#import <Foundation/Foundation.h>
#import <stdio.h>
#import <unistd.h>
#import <signal.h>
#import "Socket.h"
#import "Server.h"

#define arraySize (8*1024)

void signal_handler(int sig);

Socket *mySocket;

/***
This program opens a text file, reads from it, and sends the
audio data down a socket to a client.
***/

int main (int argc, const char * argv[]) {
    NSAutoreleasePool * pool = [[NSAutoreleasePool alloc] init];

    // declarations
    char start[arraySize];
    NSData *transit;
    int port; port = 3030;
    unsigned int bytesRead;
    NSString *path;
    const char *pathStr;
    const char *filePath = "/Volumes/My Precious/Users/gappin/Desktop/The Folder/bigTextFile.txt";
    FILE *file;
    static struct sigaction act;

    // trap SIGINT
    act.sa_handler = *signal_handler;
    sigfillset(&(act.sa_mask));
    sigaction(SIGINT, &act, NULL);
    
    // open the file
    path = [[NSString alloc] initWithCString:filePath];
    pathStr = [path fileSystemRepresentation];
    file = fopen(pathStr, "r");
    if (!file) {
        perror(pathStr);
        return 21;
    }

    // initialize socket
    mySocket = [[Socket alloc] init];
    [mySocket listenOnPort:port];
    NSLog(@"Socket created. Listening on port:%i\n", port);
    [mySocket acceptConnection];
    NSLog(@"Connection established.\n");
//    [mySocket setBlocking:FALSE];

    while (!feof(file) && [mySocket isConnected]) {
        // read from the file
        bytesRead = AIFFRead(file, start, arraySize);
        NSLog(@"Bytes read from file:%i\n", bytesRead);
        
        // transmit the data
        NSLog(@"Sending data.");
        transit = [[NSData alloc] initWithBytes:start length:(arraySize * sizeof(char))];
        
        [mySocket writeData:transit];
        
        [transit release];

//        getchar();
        usleep( 10 * 1000 * 1000);
    }

    if ( [mySocket isConnected] ) {
        [mySocket release];
    }    
    NSLog(@"Normal Termination.\nGoodbye.\n");

    [pool release];
    return 0;
}

void signal_handler(int sig) {
    NSLog(@"^C Handled.\nGoodbye.\n");
    if ( [mySocket isConnected] ) {
        [mySocket release];
    }
    exit(1);
}